#ifdef _WIN32
#include "windows.h"
#include "direct.h"
#endif

#include "string.h"

#include "SDL.h"
#include "SDL_ttf.h"

#include "BList.h"
#include "auxiliar.h"

#include "variables.h"
#include "mog2.h"
#include "animscript.h"

#include "BWindow.h"
#include "BFileListWnd.h"
#include "BActiveWindow.h"
#include "AnimScriptWnd.h"
#include "TileViewWnd.h"
#include "TileSelectionWnd.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

BTileSelectionWnd::BTileSelectionWnd(int x,int y,int dx,int dy,OBJECT *o,int *r,TTF_Font *font) : BActiveWindow(x,y,dx,dy,font)
{
	BButton *b;
	int but_dx,but_dx2;

	but_dx=get_text_width("NONE",font)+10;
	b=new BButton(10,4,but_dx,12,"NONE",1);
	buttons.Add(b);

	but_dx2=get_text_width("CANCEL",font)+10;
	b=new BButton(20+but_dx,4,but_dx2,12,"CANCEL",2);
	buttons.Add(b);

	object=o;
	res=r;

	tv=new BTileViewWnd(10,20,dx-20,dy-30,o,r,font);

} /* BTileSelectionWnd::BTileSelectionWnd */ 


BTileSelectionWnd::~BTileSelectionWnd()
{
	delete tv;
} /* BTileSelectionWnd::BTileSelectionWnd */ 


void BTileSelectionWnd::contens_size(int *dx,int *dy)
{
	*dx=old_dx;
	*dy=old_dy;
} /* BTileSelectionWnd::contens_size */ 



bool BTileSelectionWnd::cycle(int stx,int sty)
{
	if (!BActiveWindow::cycle(stx,sty)) return false;

	if (!tv->cycle(stx+10,sty+20)) return false;
	if (tv->is_dirty()) set_dirty();

	return true;
} /* BTileSelectionWnd::cycle */ 



void BTileSelectionWnd::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{
	SDL_Rect r;

	SDL_FillRect(sfc,0,0x0000007f);

	r.x=1-stx;
	r.y=1-sty;
	r.w=dx-2;
	r.h=dy-2;
	SDL_FillRect(sfc,&r,0x000000ff);

	BActiveWindow::draw_contens(sfc,stx,sty,dx,dy);

	tv->draw(sfc,10-stx,20-sty,dx-20,dy-30);

} /* BTileSelectionWnd::draw_contens */ 


bool BTileSelectionWnd::button_pressed(int ID)
{
	switch(ID) {
	case 1:
		*res=ANIM_NOBITMAP;
		return false;
		break;

	case 2:
		*res=ANIM_INVALID;
		return false;
		break;

	} /* switch */ 

	return false;
} /* BTileSelectionWnd::button_pressed */ 

